--- old/usr/src/tools/smatch/src/check_kernel_printf.c	Mon Aug  5 08:38:00 2019
+++ new/usr/src/tools/smatch/src/check_kernel_printf.c	Mon Aug  5 08:38:00 2019
@@ -521,6 +521,15 @@
 			fmt[0], tag, vaidx, type_to_str(type));
 }
 
+static void time_and_date(const char *fmt, struct symbol *type, struct symbol *basetype, int vaidx)
+{
+	assert(tolower(fmt[0]) == 't');
+
+	if (fmt[1] == 'R' && !is_struct_tag(basetype, "rtc_time"))
+		sm_error("'%%ptR' expects argument of type struct 'rtc_time', argument %d has type '%s'",
+			 vaidx, type_to_str(type));
+}
+
 static void check_clock(const char *fmt, struct symbol *type, struct symbol *basetype, int vaidx)
 {
 	assert(fmt[0] == 'C');
@@ -756,6 +765,9 @@
 	case 'd':
 		dentry_file(fmt, type, basetype, vaidx);
 		break;
+	case 't':
+		time_and_date(fmt, type, basetype, vaidx);
+		break;
 	case 'C':
 		check_clock(fmt, type, basetype, vaidx);
 		break;
